Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
-  trait PatternTypers extends AnyRef

  A pattern match such as

  A pattern match such as

  x match { case Foo(a, b) => ...}

  Might match an instance of any of the following definitions of Foo. Note the analogous treatment between case classes and unapplies.

  case class Foo(xs: Int*) case class Foo(a: Int, xs: Int*) case class Foo(a: Int, b: Int) case class Foo(a: Int, b: Int, xs: Int*)

  object Foo { def unapplySeq(x: Any): Option[Seq[Int]] } object Foo { def unapplySeq(x: Any): Option[(Int, Seq[Int])] } object Foo { def unapply(x: Any): Option[(Int, Int)] } object Foo { def unapplySeq(x: Any): Option[(Int, Int, Seq[Int])] }

  Definition Classes
    typechecker
- PatternTyper

t

scala.tools.nsc.typechecker.PatternTypers

# PatternTyper 

###

#### trait PatternTyper extends AnyRef

Self Type
  Analyzer.Typer
Source
  PatternTypers.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
typer, ScaladocTyper, InteractiveTyper, Eraser, BodyDuplicator, BodyDuplicator, ImplicitSearch, TreeChecker, Typer
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. PatternTyper
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Analyzer.PatternTyper to any2stringadd[Analyzer.PatternTyper] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Analyzer.PatternTyper, B)
   Implicit
     This member is added by an implicit conversion from Analyzer.PatternTyper to ArrowAssoc[Analyzer.PatternTyper] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def doTypedUnapply(tree: Global.Tree, fun0: Global.Tree, fun: Global.Tree, args: List[Global.Tree], mode: Mode, pt: Global.Type): Global.Tree
9.  def ensuring(cond: (Analyzer.PatternTyper) ⇒ Boolean, msg: ⇒ Any): Analyzer.PatternTyper
   Implicit
     This member is added by an implicit conversion from Analyzer.PatternTyper to Ensuring[Analyzer.PatternTyper] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Analyzer.PatternTyper) ⇒ Boolean): Analyzer.PatternTyper
    Implicit
      This member is added by an implicit conversion from Analyzer.PatternTyper to Ensuring[Analyzer.PatternTyper] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: ⇒ Any): Analyzer.PatternTyper
    Implicit
      This member is added by an implicit conversion from Analyzer.PatternTyper to Ensuring[Analyzer.PatternTyper] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Analyzer.PatternTyper
    Implicit
      This member is added by an implicit conversion from Analyzer.PatternTyper to Ensuring[Analyzer.PatternTyper] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
15.  def extractorForUncheckedType(pos: Global.Position, pt: Global.Type): Global.Tree
16.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
17.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Analyzer.PatternTyper to StringFormat[Analyzer.PatternTyper] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
18.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
19.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
20.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
21.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
22.  final def notify(): Unit
    Definition Classes
      AnyRef
23.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
24.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
25.  def toString(): String
    Definition Classes
      AnyRef → Any
26.  def typedArgsForFormals(args: List[Global.Tree], formals: List[Global.Type], mode: Mode): List[Global.Tree]
27.  def typedConstructorPattern(fun0: Global.Tree, pt: Global.Type): Global.Tree
28.  def typedInPattern(tree: Global.Typed, mode: Mode, pt: Global.Type): Global.Tree
    Attributes
      protected
29.  def typedStarInPattern(tree: Global.Tree, mode: Mode, pt: Global.Type): Global.Tree
    Attributes
      protected
30.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
33.  def wrapClassTagUnapply(uncheckedPattern: Global.Tree, classTagExtractor: Global.Tree, pt: Global.Type): Global.Tree
34.  def →[B](y: B): (Analyzer.PatternTyper, B)
    Implicit
      This member is added by an implicit conversion from Analyzer.PatternTyper to ArrowAssoc[Analyzer.PatternTyper] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Analyzer.PatternTyper to any2stringadd[Analyzer.PatternTyper]

### Inherited by implicit conversion StringFormat from Analyzer.PatternTyper to StringFormat[Analyzer.PatternTyper]

### Inherited by implicit conversion Ensuring from Analyzer.PatternTyper to Ensuring[Analyzer.PatternTyper]

### Inherited by implicit conversion ArrowAssoc from Analyzer.PatternTyper to ArrowAssoc[Analyzer.PatternTyper]

### Ungrouped